---
layout: cp
title: Research Computing Upgrade
author: Gingeropolous
date: May 10, 2022
amount: 51
milestones:
  - name: Expand data storage on existing server
    funds: 27
    done: 26 July 2022
    status: finished
  - name: Month 1 support 
    funds: 8
    done: 26 July 2022
    status: finished
  - name: Month 2 support 
    funds: 8
    done: 23 August 2024
    status: finished
  - name: Month 3 support 
    funds: 8
    done: 24 August 2024
    status: finished
payouts:
  - date: 27 December 2022
    amount: 35
  - date: 4 September 2024
    amount: 16
---

# Gingeropolous CCS Request


Hello all! This CCS proposal is to fund me to work part time on monero in various capacities, fund some monero research computing infrastructure, and to support my official training in Computer Science. I am a long time member of the monero community, and I've always wanted to dedicate more time to Monero. I am in a place professionally where I can potentially pivot to become "full time monero" if support is available. I have a lot of projects that have interested me over the years. This first CCS is to increase the storage capacity of a particular machine, as Rucknium is embarking on a project that needs a lot of fast storage. In addition, I also requests funds for my time. In the future, I plan on submitting additional CCS requests to further improve computational and storage infrastructure for the monero research and development community, perform various monero R&D, and begin my official computer science education / training. 

# Who:

I am Gingeropolous, long time community member and tinkerer. Over the years I've worked on various things in Monero. Notable things include webmin for xmrchain.net, testing fluffyblocks on mainnet (https://www.reddit.com/r/Monero/comments/6dords/help_test_fluffyblocks_compact_blocks_whatever/), and being sometimes the only mining pool for testing PoW variants during the ASIC war (remember killallasics.moneroworld.com ?). For some background, I do hold a PhD in a field of biomedical science, and I am/was a Research Assistant Professor. I came into monero years ago with no cryptocurrency, linux, or software development experience - but I've been building and working with computers for decades. I've had a lot of help from many monero contributors, and I feel i've reached a point of competance that I hope is valuable to the project. This CCS will hopefully be my first of many. During the dedicated and protected time (that I will request in the future), I hope to become even more valuable to the project through various training, infrastructure, and research activities. I have already begun my path to getting a Masters in Computer Science by working on the pre-requisite courses, as I have nothing on paper that indicates that I will perform well in a CS degree. 

# What: 

## Infrastructure: high end servers and tools for monero development and research

## Specific to this CCS: Funds to increase storage on existing hardware to fascilitate current research

I would like to build, maintain and administrate high-end servers for monero development and research in a cost effective manner. From my own experience in monero, it's ideal if you can just do things faster. Build something, test it / run it, tweak something, do it again. Time spent waiting for the computer to do something means you lose time and momentum - and this momentum, and time in general, is scarce for open source contributors that mostly contribute in their free time. Thus, I plan on providing high end servers to the monero developer and researcher community. Lots of ram, virtually unlimitted storage, and threads everywhere. 

I've already done this at a small scale with my own funds, providing access to my existing mining hardware (with some additional memory and storage upgrades just for monero R&D) to researchers like Sarang, Rucknium, and ack-j; members of the Noncesence Research Lab, and developers like TheCharlatan, mj-xmr, jberman. For example, ack-j recently told me "Hey so that the multiprocessing worked great yesterday and saved an estimated 100 days compared to running it on my VM with 1 thread." Renting this kind of hardware from a hosting provider can get expensive. Furthermore, CCS investments in this infrastructure represesent one-time investments. Once it is built, I will provide access to the monero R&D community as long as I can keep the lights on (with or without community funding). The end goal of this effort (built over the years) will be a veritable research computing cluster with job scheduling etc (if people want that - sometimes direct shell is just easier). For the time being though, it will be much simpler - custom VM provisioning (if needed) and dedicated metal. Additionally, I will provide i2p and/or onion connections to allow any member of the community to use the resources in a private manner.  

Granted, the building of this infrastructure creates an obviously centralized thing, and I'm not a huge fan of that. For the time being, I think it will be OK, but part of my future effort will include a way by which other monero folks rich in computer resources (e.g., those with big monero mining ops) can add their computers to a global monero research computational resource. To this end, a future project will include scripts that allow for anyone to launch their own Monero Research and Development cluster. For instance, a way for someone to build their own databases etc. 

## Existing infrastructure in the Monero Research Computing garage:
HPE Proliant DL325 Gen10 AMD EPYC 7402P 48 thread, 64 GB RAM
ASUS Zenith 2 Alpha with 64 thread Threadripper 3970x , 256 GB ram, 2TiB NVME, 24TiB HDD. (I maxed out the RAM on this one)
some sad old opterons with 96 GB ram
~6 3900x AMD systems with 16-64gb ram and various storage abilities.
1 1920x threadripper with 32gb ram 
old laptops so we can run performance tests on scrap

UPS:

N1C L-series 3000VA 

Network:
1 gbps up/down with unlimitted bandwidth
1 gbps 48 port network switch

# Funds requested in this CCS:
A. 5 * 4096 Gb  NVME SSDs to max out the high-speed storage capability of the Zenith 2 Alpha. Market prices have these around $1k.  Currently considering Kingston KC3000 M.2

B. 3 months of part time salary support and partial costs: this will allow me to spend more time with the hardware (for instance, that new UPS isn't installed yet), focus on computer science pre-reqs, and assist with electrical costs. During this time I will also assist with whatever Monero things I can assist with - usually these involve testing software and trying to find bugs. I will also put more time into helping folks on Reddit, IRC, and Matrix. I am requesting $1500 a month. 

# Timeline / Milestones:

Storage: I will purchase the drives upon full funding of the request, and request a payout once I provide a screenshot of the drives mounted. 
Monthly: I will provide an update (roughly a month) when I feel I have completed enough to warrant a payout.  

I have calculated the XMR based on the USD fiat price of ~~$165~~. $185 (roughly using the daily 21 ema as of commit) 

I am open to any suggestions for this proposal. 

Expiration 2022-12-01 (YYYY-MM-DD). If not all claimed, released to the general fund. 

51 xmr total, 27 for SSDs, 8x3 for monthly support
