---
layout: cp
title: Translation Coordinator for the Monero Project
author: netrik182
date: October 6, 2021
amount: 11
milestones:
  - name: One month work
    funds: 11
    done: 3 December 2021
    status: finished
payouts:
  - date: 8 December 2021
    amount: 11
---

## Translation Coordinator for the Monero Project
Translations have always been an important part of this community and an essential tool to spread Monero to everyone. ErCiccione has been the manager of this workgroup for a long time (see their proposals at the bottom) and recently has been looking for someone to take on these responsibilities as they are focusing their time on other projects now (e.g. Haveno).

The Monero Project has always benefited from having well structured and consistent translations across its many resources thanks to ErCiccione and many other contributors/translators. After they announced on #monero-translations that they are looking for someone to take care of it, I want to step in and keep that going.

## About me
I have been involved with FLOSS and Monero-specific translation work for more than 5 years now. I also run https://monerobrasil.org/ and [#monero-brasil](https://matrix.to/#/#monero-brasil:monero.social).

### My profiles
- repo.getmonero.org [profile](https://repo.getmonero.org/users/netrik182/activity) where I contributed before Pootle (and now Weblate) was a thing.
- Weblate [profile](https://translate.getmonero.org/user/netrik182/) where I contribute to getmonero.org, Monero GUI translations, Monero Means Money, and other Dr. Kim's videos, etc.
- GitHub [profile](https://github.com/netrik182) where most things were done.

### Previous Work
- **Monero Ecosystem Translations:** Provided the transcription, captions and translations. As well as the terminology guides. You can check all [here](https://github.com/monero-ecosystem/monero-translations/pulls?q=netrik182) and [here](https://github.com/ajs-xmr/moneromovie/pulls?q=is%3Apr+author%3Anetrik182+).
- **Monero Website and Monero GUI:** Most of my contributions to GUI Wallet are on Weblate. Contributions I made on GitHub [here](https://github.com/monero-project/monero-gui/pulls?q=netrik182+) and [here](https://github.com/monero-project/monero-site/pulls?q=netrik182).
- **Monero Outreach:** I contributed with translation, transcription and revision of many [outreach materials](https://github.com/monero-ecosystem/outreach-docs/pulls?q=netrik182).
- **Monerujo:** Translation and review of [Monejuro](https://github.com/m2049r/xmrwallet/pulls?q=netrik182).
- **AgoraDesk/LocalMonero:**  [Translation and review](https://github.com/AgoraDesk-LocalMonero/translation/pulls?q=is%3Apr+author%3Anetrik182) of their website.
- **Mastering Monero:**  [Translation](https://github.com/monerobook/monerobook/pull/94) and [review](https://github.com/monerobook/monerobook/pull/93). Also see [the book itself](https://netrik182.gitlab.io/docs-monerobrasil.org/masteringmonero/) and the [CCS proposal](https://ccs.getmonero.org/proposals/netrik182-mastering-monero-translation.html).

## Responsibilities
Things the manager must take care of are:
1. Manage translators and their work on Weblate for the following projects:
- **Community:** https://translate.getmonero.org/projects/community/
- **Getmonero:** https://translate.getmonero.org/projects/getmonero/
- **Getmonero user guides:** https://translate.getmonero.org/projects/getmonero-user-guides/
- **Monero CLI and GUI:** https://translate.getmonero.org/projects/monero/
2. Manage translators and their work on GitHub for the following projects:
- **Monero Translations:** https://github.com/monero-ecosystem/monero-translations
- **Monero Website:** https://github.com/monero-project/monero-site
- **Monero GUI Guide (translation only):** https://github.com/monero-ecosystem/monero-GUI-guide
3. Maintain a list of contributors and their working language;
4. Manage translations on Weblate (this includes adding notes and keeping an eye on the entire platform for spam, etc.);
- Making sure strings have clarifications and explanations where necessary;
- Communicate with ErCiccione when translations are ready so they can push them to the repository (where they are supposed to be: /monero, /monero-site, /monero-gui, /monero-translations for subtitles);
5. Take care of translations-related CCS (the current system is not optimal and needs to be improved. See more bellow.);
6. Unify, update and maintain documentation on different repositories;
- [/monero](https://github.com/monero-project/monero/blob/master/docs/README.i18n.md) instructions;
- [/monero-translations](https://github.com/monero-ecosystem/monero-translations) instructions;
- [/monero-gui](https://github.com/monero-project/monero-gui#translations) instructions;
- [/monero-site](https://github.com/monero-project/monero-site#translation) instructions;
- [Weblate](https://github.com/monero-ecosystem/monero-translations/blob/master/Weblate.md) instructions;
- [Translations tips](https://github.com/monero-ecosystem/monero-translations/blob/master/translation-tips.md);
- [Monerujo](https://github.com/monero-ecosystem/monero-translations/blob/master/translate-monerujo.md) instructions;
7. Answer questions and coordinate people in the chat-rooms (#monero-translations on Libera/Matrix);
8. Make sure when there are translations available on Weblate, they are pushed upstream (repository they belong to);
9. Provide updates to the community about the state of the translations and workgroup-related activities during #monero-community meetings;
10. Issue progress reports on a monthly basis as GitLab comments and share within the community (e.g. Reddit/Matrix/IRC).

## Limitation of Scope
ErCiccione will keep managing the backend side of things (update Weblate, bug issues, etc). I will maintain the languages on Weblate, help and find translators, update the documentation, etc. as highlighted above.

## Translation-related CCS proposals
One of the first tasks of this role will be to rethink the whole process of contributors using the CCS to fund their translation efforts. We have had problems with low quality work in the past and although some rules have been discussed and laid out with the help from Core, I want to focus on defining and _enforcing_ some basic rules for translation-related CCS's in the future, accepting work from:
- Translators with a provable portfolio as professional translators
- Contributors of the Localization Workgroup that have a track record of delivering high quality translations (work that has been reviewed by others and deemed of high quality, for example)

The end goal is to guarantee the Monero Project has its resources translated and that these translations are of high quality. We plan to establish a hybrid approach in which community members could contribute if they wanted to (as volunteers or paid work) given the rules above and in case we fail to meet the above requirements for any given language a.k.a. these contributors do not exist or are of bad quality, they could be replaced with professional resources.

## Funding
I want to open this CCS to work for the first month as a trial run and later on if the Community thinks it was worth it, I can move to 3-months proposals for long-term commitment. This proposal will consist of 20h/week for 4 weeks at a rate of 30€/h, with a total of 11 XMR (1 xmr = 219€ at Kraken). _I will update the rate shortly before merging (if merged at all)._

## Milestones for the first month:
1. **Review, update and unify translations instructions from item 6 above:** the idea is to have a single document with all instructions laid out and then each repository could reference this _source_ material. This will simplify maintenance and also help onboarding new contributors. I think this is the most important milestone and hence it will take most of my time.
2. **Translation-work coordination:** this covers the whole process of managing translations, community and outsourced translators and so on. It is the bulk of responsibilities and must be performed continually. I would also put in here the community reports/updates on a monthly basis and participation on -community meetings.

## Future ideas
1. **Work with Core and ErCiccione to grab statistics from Monero Website:** the idea is to assess visitors preferred language and use that information to focus on which language we need to prioritize and also which resources are most valuable to translate first. This will enable us to create a prioritization list of sorts.
2. **Create a Translation Fund for continued maintenance of translation work:** I have talked with some Core Team members and they expressed the possibility of a Translation Fund existing and those funds being used to outsource specific work to translation outlets in the absence of community members meeting the criteria of high quality work. Having money set apart for this specific goal together with the statistics of language/resource prioritization list will help us achieve the end goal of ensuring Monero is translated into the most needed languages.

## Expiration
October 31, 2021

## Past coordination proposals by ErCiccione for reference
- https://forum.getmonero.org/22/completed-tasks/89232/coordinator-for-localization-group-various-maintenance
- https://forum.getmonero.org/22/completed-tasks/90000/monero-localizations-coordinator-2nd-ffs
- https://forum.getmonero.org/22/completed-tasks/90271/coordinator-of-the-localization-workgroup-3-more-months-erciccione
- https://forum.getmonero.org/9/work-in-progress/90800/erciccione-coordinator-of-the-localization-workgroup-translations-another-quarter
- https://forum.getmonero.org/9/work-in-progress/91261/erciccione-coordinator-of-the-localization-workgroup
- https://ccs.getmonero.org/proposals/ErCiccione-localizations.html
- https://ccs.getmonero.org/proposals/ErCiccione-Weblate.html
