---
layout: cp
title: "Sarang: research funding for 2019 Q3"
author: Sarang Noether
date: 3 June 2019
amount: 355
milestones:
  - name: Funding is released
    funds: 100% (355 XMR)
    done: 14 June 2019
    status: finished
  - name: Work is done
    funds: 0% (0 XMR)
    done: 30 September 2019
    status: finished
payouts:
  - date: 14 June 2019
    amount: 355 XMR
---
Hello to you. This is Dr. Sarang Noether, requesting ongoing research funding for the next quarter. My current funding period is complete at the end of June, and I'm ready to go for another three months of research and development for the Monero Research Lab.

My monthly reports for the current funding period are available, and I encourage you to read them:
- [April](https://repo.getmonero.org/monero-project/ccs-proposals/merge_requests/34#note_5903)
- [May](https://repo.getmonero.org/monero-project/ccs-proposals/merge_requests/34#note_6373)
- June (forthcoming)

The last few months have seen plenty of work on formalization and testing of new signature schemes, output selection, sublinear transaction protocols, Bulletproofs, input merging, and more.

As always, the list of research topics of interest is constantly evolving! Some items of interest:
- CLSAG review and deployment: Both the mathematics and implementation of the CLSAG signature scheme should be reviewed prior to deployment.
- Analysis of sublinear transaction protocols: This includes Lelantus, RingCT3.0, and Omniring. Each presents different tradeoffs in efficiency, privacy, and usability.
- Ristretto: The use of an abstraction layer may provide a useful way to take advantage of some of the efficiency and security benefits of this curve representation.
- Output selection: There are aspects to this (like fixed output sets) that are of interest, especially as we look toward transaction protocols with larger practical anonymity sets.
- Dynamic block size improvements: This is a holdover from my last request that there was not time to investigate properly.
- Efficient circuit code: Several different scaling solutions to zero-knowledge circuit evaluation, from Bulletproofs to Spartan, are of interest.
- Literature review: This is, as always, ongoing.
- Outreach and education: These typically include episodes of Breaking Monero, Coffee Chats, and other avenues.
- The unexpected: Research rarely goes precisely the way we expect, so it is important to stay on top of whatever new proposals or issues arise unexpectedly.

As always, I work hard to provide value to the community and project for the value you provide here. For the funding period beginning July 2019 and continuing through September 2019, my request continues to be 10415 USD per month, my assessment of market compensation for an independent Ph.D. researcher in the United States with a record of quality work. Therefore, the request total is **355 XMR**, based on a 14-day exponential moving average of 88 USD/XMR taken from Kraken.

**Please read this paragraph carefully.** As was done for my previous request, this request will be paid out in full immediately when it is funded. This greatly reduces the volatility that otherwise arises from being paid out over time for ongoing work, and ensures that the value of donations is the value that reaches me. I hope that my record of work for the project speaks for itself, and that I continue to earn your trust to continue that work.

Comments, questions, and discussion about this proposal are welcome. This community continues to stand out as unique for its ongoing support of research and development, and I want to thank everyone who supports the project in whatever way they choose. Let's continue to build and improve Monero. Onwards!
